/* www.sgm.siedlce.pl

Program do ustalenia neutrum serwa. Po polaczeniu poprzez
program terminalowy wciskajac odpowiednie klawisze zwiększamy
szerokość impulsu (q - zgrubnie=10uS, w - precyzyjnie=1uS),
lub zmniejszamy (a - zgrubnie=10uS, s - precyzyjnie=1uS),
obserwując kiedy oś silnika serwa się zatrzyma.

*/

#include <Servo.h>  // dołączenie biblioteki
Servo myservo;      // utworzenie obiektu do sterowania serwem 

                    // deklaracje stałych i zmiennych

int posMin = 1200;  // zmienne okreslające zakres testu->
int posMax = 1700;  // ->serwa w mikrosekundach, neutrum=1500uS ->
                    // ->minimum 1000uS, maksimum 2000uS
int posN = 1500;    // zmienna do zapamietania neutrum               



const int led1 = 13; // LED na płytce potwierdzajacy wcisniecie
                     // klawisza 
int inByte = 0;      // zmienna do odczytu znaku
char znak = ' '; 
                     // przypisanie klawiszy do komend
char incH = 'q';     // zgrubne zwiekszenie szerokosci impulsu
char incL = 'w';     // precyzyjne zwiekszenie szerokosci impulsu
char decH = 'a';     // zgrubne zmniejszenie szerokosci impulsu
char decL = 's';     // precyzyjne zmniejszenie szerokosci impulsu

int IncDec = 0; 


                  // procedura setup'u, uruchamiana jednorazowo przy
                  // starcie programu 
void setup() 
{                        // programowe podłącznie obiektu
  myservo.attach(9);     // "myservo" do Pin9 
  Serial.begin(9600);    // inicjalizacja interfejsu RS 
  pinMode(led1, OUTPUT); // deklaracja wyjscia dla Led1                                         
} 

void loop()              // glowna petla programu
 {
  // program wchodzi w petle gdy pojawi sie znak na RS
  while (Serial.available() > 0)
  {
    inByte = Serial.read(); 
    znak = inByte;
    
    if (znak == incH) {
     IncDec = 10;
    }
    if (znak == incL) {
     IncDec = 1;
    }
    if (znak == decH) {
     IncDec = -10;
    }
    if (znak == decL) {
     IncDec = -1;
    }
    posN += IncDec;
    IncDec = 0;
    
    if (posN < posMin) {
     posN = posMin; 
    }
    if (posN > posMax) {
     posN = posMax; 
    }
    
    myservo.writeMicroseconds(posN);  // ustaw serwo w pozycje posN     
         
    digitalWrite(led1, HIGH);   
    delay(200);
    digitalWrite(led1, LOW);
      
    Serial.println(posN);
  }
 }

